#include <stdio.h>
#include "interface.h"
#if 0
#include "parallel.h"
#endif

#if 0
#define DEBUG_check
#endif

void check_(complex *BRAU, complex *BRAL, complex *STAIRS, short *KTNO,
            int *LBRI, int *NELI, short *IBUSO, short *INODIA, int *NBUS)
{
   FILE *OutputFile;
   char OutputFilename[80];
   int i;
   int j;

   int M;
   int NODEA;
   int NORDA;
   int NODEB;
   int NORDB;
   int Limits;
   int Band_width;

   int JB;
   int NZero;
   static File_num = 0;
   int *inodia;

   int Symmetric = TRUE;

   sprintf(OutputFilename, "%s%d.dat", "Edge", File_num);

   if ((OutputFile = fopen(OutputFilename, "w")) == NULL)
   {
      perror("check");
      exit(1);
   }

   Band_width = *NBUS - 1;

#ifdef DEBUG_check
   fprintf(OutputFile, "  LOCA NODIAY  IBUSO INODIA\n");
   for (i = 0; i < *NBUS; i++)
   {
      fprintf(OutputFile, "%6d %6hd %6hd %6d\n", i + 1, NODIAY[i], IBUSO[i],
              INODIA[i]);
   }
#endif

   if ((inodia = (int *) malloc(sizeof(int) * *NBUS)) == NULL)
   {
      perror("check(): allocation inodia");
      exit(1);
   }

   for (i = 0; i < *NBUS; i++)
   {
      NODEA = IBUSO[i] - 1;
      inodia[NODEA] = i;
   }

#ifdef DEBUG_check
   fprintf(OutputFile, "     I  IBUSO INODIA inodia\n");
   for (i = 0; i < *NBUS; i++)
   {
      fprintf(OutputFile, "%6d %6hd %6hd %6d\n", i + 1, IBUSO[i],
              INODIA[i], inodia[i]);
   }
#endif

   for (i = 0; i < *NBUS - 1; i++)
   {
      NODEA = (int) IBUSO[i] - 1;

#ifdef DEBUG_check
      fprintf(OutputFile, "NODEA = %d\n", NODEA);
#endif
      NORDA = inodia[NODEA];

      fprintf(OutputFile, "A[%d][%d] (%d, %d) = (%g, %g)\n", NODEA, NODEA,
              NORDA, NORDA, STAIRS[NODEA].real, STAIRS[NODEA].imag);

      M = LBRI[NODEA] - 1;

      NZero = 0;
      j = 0;
      do
      {
         j++;
         NODEB = (int) KTNO[M] - 1;
#ifdef DEBUG_check
      fprintf(OutputFile, "NODEB = %d\n", NODEB);
#endif
         if (NODEB >= 0)
         {

#ifdef DEBUG_check
            fprintf(OutputFile, "NORDA = %d\n", NORDA);
#endif
            NORDB = inodia[NODEB];

#ifdef DEBUG_check
            fprintf(OutputFile, "NORDB = %d\n", NORDB);
#endif
            if (NORDB > NORDA)
            {
               if (Band_width > NORDB)
                  Band_width = NORDB;
               NZero++;
               JB = (M >> 1);

               if (NODEA < NODEB)
               {
#ifdef DEBUG_check
                  fprintf(OutputFile, "%d\n", JB);
#endif
                  fprintf(OutputFile, "A[%d][%d] (%d, %d) = (%g, %g)\n",
                          NODEA, NODEB, NORDA, NORDB,
                          BRAU[JB].real, BRAU[JB].imag);
                  fprintf(OutputFile, "A[%d][%d] (%d, %d) = (%g, %g)\n",
                          NODEB, NODEA, NORDB, NORDA,
                          BRAL[JB].real, BRAL[JB].imag);
#if 0
                  fprintf(OutputFile, "%d %d\n", NODEB, NODEA);
#endif
               }
               else
               {
#ifdef DEBUG_check
                  fprintf(OutputFile, "-%d\n", JB);
#endif
                  fprintf(OutputFile, "A[%d][%d] (%d, %d) = (%g, %g)\n",
                          NODEA, NODEB, NORDA, NORDB,
                          BRAL[JB].real, BRAL[JB].imag);
                  fprintf(OutputFile, "A[%d][%d] (%d, %d) = (%g, %g)\n",
                          NODEB, NODEA, NORDB, NORDA,
                          BRAU[JB].real, BRAU[JB].imag);
#if 0
                  fprintf(OutputFile, OutputFile, "%d %d\n", NODEA, NODEB);
#endif
               }
               if ((BRAL[JB].real != BRAU[JB].real)
                   || (BRAL[JB].imag != BRAU[JB].imag))
               {
                  fprintf(OutputFile, "Tag not summetric values\n");
                  Symmetric = FALSE;
               }
            }
         }
         M = NELI[M] - 1;
      } while ((M >= 0) && (j < *NBUS));
   }

   NODEA = (int) IBUSO[*NBUS - 1] - 1;
   NORDA = inodia[NODEA];

   fprintf(OutputFile, "A[%d][%d] (%d, %d) = (%g, %g)\n", NODEA, NODEA,
           NORDA, NORDA, STAIRS[NODEA].real, STAIRS[NODEA].imag);
   fprintf(OutputFile, "Band width = %d\n", Band_width);
#if 0
   fprintf(OutputFile, "matrix is %s\n", (Symmetric == TRUE) ? "Symmetric" :
           "Not Symmetric");
#endif

   fclose(OutputFile);

   free(inodia);
   File_num++;
}

